class
	CE_VOID_POINTER

inherit
	CE_POINTER [ANY]

create
	make,
	make_shared,
	make_shared_with_count,
	make_cast

feature {ANY}

	element_size: INTEGER_32 = 1

feature {ANY}

	i_th alias "[]" (a_index: INTEGER_32): ANY assign set_i_th
		do
			(create {EXCEPTIONS}).raise ("Void pointers can't be dereferenced.")
		end

	set_i_th (a_item: ANY; a_index: INTEGER_32)
		do
			(create {EXCEPTIONS}).raise ("Void pointers can't be dereferenced.")
		end

feature {ANY}

	plus alias "+" (i: INTEGER_32): CE_VOID_POINTER
		local
			l_count: INTEGER_32
		do
			if byte_count = {INTEGER_32}.Max_value then
				l_count := count
			else
				l_count := count - i
			end
			create Result.make_shared_with_count (c_pointer + i, l_count)
		end

end
